  /************************************************************************
 *	@file			ModelDemo/XKMD2Model.h
 *	@brief			ͶȡMD2ļʽ
 *
 *	@author			Xiong Xinke
 *	@copyright		Xiong Xinke
 *	@date			2005-2-26 16:54:17
 ************************************************************************/
#ifndef __MODELDEMO_XKMD2MODEL_H__
#define __MODELDEMO_XKMD2MODEL_H__

#include "XKGlobals.h"
#include <vector>

using namespace std;


//MD2ģ͵ÿεĶӳб
struct MD2_IndexList
{
	int		m_nA , m_nB, m_nC;
	float	m_fUA , m_fVA;
	float	m_fUB , m_fVB;
	float	m_fUC , m_fVC;
};

//MD2ģ͵Ķб
struct MD2_VertexList
{
	float m_fX , m_fY , m_fZ;
};

//MD2ģ͵֡б,ÿһָ֡һб
struct MD2_FrameList
{
	MD2_VertexList* m_pVtxList;
};

//άʸ
struct MD2_Vector3
{
	float m_fX , m_fY , m_fZ;
};

//ӳ
struct MD2_UVTexCoord
{
	short int m_nU , m_nV;
};

//MD2ģеƬ
//Щӳļ
struct MD2_Triangle
{
	short int m_nIndexA;
	short int m_nIndexB;
	short int m_nIndexC;
	short int m_nIndexA_UV;
	short int m_nIndexB_UV;
	short int m_nIndexC_UV;
};

//MD2ģеεĶ㣬ǵֽڵ
struct MD2_TriVertex
{
	unsigned char m_X , m_Y , m_Z;
	unsigned char m_LightNormalIndex;
};

//MD2ֶ֡(scale)
//ƽ(translate)ŵϢ
struct MD2_AliasFrame
{
	float m_fScaleX;
	float m_fScaleY;
	float m_fScaleZ;
	float m_fTranslateX;
	float m_fTranslateY;
	float m_fTranslateZ;
	char  m_szName[16];
	MD2_TriVertex m_TriVtx[1];
};

//MD2ļͷݣݽṹĳԱ
//˳Ҫϸ岻ܵҵ
struct MD2_FileHeader
{
	int m_nIdentify;		//ʶ
	int m_nVersion;			//汾
	int m_nSkinWidth;		//
	int m_nSkinHeight;		//
	int m_nFrameSize;		//ÿ֡ĴСֽΪλ
	int m_nSkinNum;			//ģƤ
	int m_nVertexNum;		//ģ͵Ķ
	int m_nUVNum;			//
	int m_nTriangleNum;		//ģƬ
	int m_nOpenGLCmdNum;	//OpenGLĿ
	int m_nFrameNum;		//֡Ŀ
	int m_nSkinsOffset;		//ƤļеƫƵַ
	int m_nTexCoordOffset;	//ӳļеƫ
	int m_nTrianglesOffset; //Ƭļеƫ
	int m_nFrameOffset;     //֡ļеƫ
	int m_nOpenGLCmdOffset; //OpenGLļеƫ
	int m_nEndOffset;		//ļλļеƫ
};

struct MD2_TriFloatVtx
{
	MD2_Vector3	m_V;
	int			m_nLightNormalIndex;
};

struct MD2_Frame
{
	MD2_Vector3		m_vMin;
	MD2_Vector3		m_vMax;
	char			m_szName[16];
	MD2_TriFloatVtx	m_V;
};

//MD2FVFģ
struct MD2_ModelVertex 
{
	D3DXVECTOR3   m_vPos;
	D3DCOLOR      m_dwDiffuse;
	D3DXVECTOR2   m_vTex;
} ;

#define FVF_MD2_MODELVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1|D3DFVF_TEXCOORDSIZE2(0) )

struct MD2_Mesh
{
	vector<MD2_ModelVertex>	m_Vertices;
};

//MD2Ķ֡
struct MD2_Animation
{
	int		m_nStart;		//MD2ʼ֡
	int		m_nEnd;			//MD2Ľ֡
	int		m_nIndex;		//
	int		m_nCurrent;		//
	string	m_strName;
};


class XKMD2Model
{
private:
	MD2_IndexList*	m_pIndexList;		//
	MD2_FrameList*	m_pFrameList;		//֡б
	int				m_nFrames;			//֡
	int				m_nVertices;		//ÿ֡Ķ
	int				m_nTriangles;		//Ƭ
	int				m_nSkins;			//Ƥ
	int				m_nUVs;				//
	int				m_nFrameSize;		//֡С
	MD2_Mesh		m_Meshes[MD2_MAX_FRAMES];			 //ÿһͶӦһmesh
	MD2_ModelVertex	m_VertexBuffer[MD2_MAX_TRIANGLES*3]; //ģ͵Ķ
public:
	vector<MD2_Animation>	m_Animation;
private:
	int Init();
public:
	XKMD2Model();
	~XKMD2Model();
	int   ReturnCurrentAnim( int nCurrent );
	float ReturnCurrentTime(int nSelect,int nNextFrame);
	int	  LoadFile( const char* szFileName );
	int	  Render( int nCurrent );
	inline int GetFrameCount();
	inline int GetVertexCount();
	inline int GetTriangleCount();
};

#endif /* __MODELDEMO_XKMD2MODEL_H__ */
